;;;; srfi-4-errors.scm  -*- Scheme -*-
;;;; Kon Lovett, Jul '18
;;;; Kon Lovett, Dec '09

(module srfi-4-errors

(;export
  error-s8vector
  error-u8vector
  error-s16vector
  error-u16vector
  error-s32vector
  error-u32vector
  error-s64vector
  error-u64vector
  error-f32vector
  error-f64vector)

(import scheme)
(import (chicken base))			; for `include'
(import (chicken type))
(import (srfi 4) type-errors-basic)

(: error-s8vector (* * #!optional * -> noreturn))
(: error-u8vector (* * #!optional * -> noreturn))
(: error-s16vector (* * #!optional * -> noreturn))
(: error-u16vector (* * #!optional * -> noreturn))
(: error-s32vector (* * #!optional * -> noreturn))
(: error-u32vector (* * #!optional * -> noreturn))
(: error-s64vector (* * #!optional * -> noreturn))
(: error-u64vector (* * #!optional * -> noreturn))
(: error-f32vector (* * #!optional * -> noreturn))
(: error-f64vector (* * #!optional * -> noreturn))

(define-error-type s8vector)
(define-error-type u8vector)
(define-error-type s16vector)
(define-error-type u16vector)
(define-error-type s32vector)
(define-error-type u32vector)
(define-error-type s64vector)
(define-error-type u64vector)
(define-error-type f32vector)
(define-error-type f64vector)

(include "srfi-4-errors.impl.scm")

) ;module srfi-4-errors
